diff -Naur --exclude=CVS --exclude=configs linux/hpc/config.c linux-openmosix/hpc/config.c
--- linux/hpc/config.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/config.c	2004-03-19 16:59:09.000000000 +0100
@@ -0,0 +1,994 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Oren Laadan, Amnon Shiloh.
+ */
+#include <linux/sched.h>
+#include <linux/reboot.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/debug.h>
+#include <linux/hpc.h>
+#include <linux/hpcctl.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <linux/slab.h>
+#include <linux/smp_lock.h>
+#include <linux/stddef.h>
+#include <linux/socket.h>
+#include <linux/in.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
+static int
+mosix_notify_reboot(struct notifier_block *this, unsigned long code, void *x)
+{
+	if(code == SYS_DOWN || code == SYS_HALT || code == SYS_POWER_OFF ||
+		code == SYS_RESTART)
+		expel(1);
+	return(NOTIFY_DONE);
+}
+
+struct notifier_block mosix_notifier =
+{
+	.notifier_call = mosix_notify_reboot,
+	.priority = 10,	/* Higher than drivers, so network still goes */
+};
+
+int PE;
+int NPE;
+int MAXPE;
+struct sockaddr my_mosix_net_address;
+
+#ifdef CONFIG_SMP
+static spinlock_t modifying = SPIN_LOCK_UNLOCKED;	/* use only TRYLOCK! */
+#endif /* CONFIG_SMP */
+
+static int pe_ready;
+
+int nmosnet;
+struct mosixnet *mosnet;
+static char *mosnetstat;
+rwlock_t mosnetstat_lock = RW_LOCK_UNLOCKED; 
+
+DECLARE_WAIT_QUEUE_HEAD(wait_for_mosix_config);
+DECLARE_WAIT_QUEUE_HEAD(wait_for_all_to_adjust);
+
+/* local subroutines */
+static int config_validate(void);
+static int config_reduce_to_common(struct mosixnet *, int);
+static int config_shutdown(void);
+
+
+/* hooks for IP network */
+static int ip_to_mosix(struct sockaddr *);
+static int ip_consistent(int, struct mosixnet *, int, int);
+static void ip_showconf(int, struct mosixnet *, int);
+static void ip_mos_to_net(int, int, struct sockaddr *);
+static int ip_addr_to_ascii(struct sockaddr *, char *, int);
+static struct mosixnet *ip_reduce_to_common(struct mosixnet *, int *);
+
+int
+config_get_status(int pe)
+{
+	int ret;
+
+	if (!mos_to_net(pe, NULL))
+		return (-ENXIO);
+	pe--;
+	read_lock(&mosnetstat_lock);
+	ret = mosnetstat[pe >> 3] & (1 << (pe & 7));
+	read_unlock(&mosnetstat_lock);
+	return(ret);
+}
+
+int
+config_set_status(int pe)
+{
+	pe--;
+	write_lock(&mosnetstat_lock);
+	mosnetstat[pe >> 3] |= (1 << (pe & 7));
+	write_unlock(&mosnetstat_lock);
+	return (0);
+}
+
+static int
+config_shutdown(void)
+{
+	struct mosixnet *svmton;
+	int svnmton, svpe, svnpe, svmaxpe;
+	int error;
+	struct task_struct *t1, *t2;
+
+	/* temporarily change configuration */
+	lock_mosix();
+	svpe = PE;
+	svnpe = NPE;
+	svmaxpe = MAXPE;
+	svmton = mosnet;
+	svnmton = nmosnet;
+	mosnet = NULL;
+	nmosnet = 0;
+	NPE = MAXPE = 0;
+	unlock_mosix();
+
+	/* bring back our processes, and expel foreign */
+	if ((error = config_validate()))
+		goto fail;
+	lock_mosix();
+	PE = 0;
+	unlock_mosix();
+	info_reconfig();
+
+	/* wakeup our daemons */
+	lock_mosix();
+	if((t1 = info_proc))
+		get_task_struct(t1);
+	if((t2 = mig_proc))
+		get_task_struct(t2);
+	unlock_mosix();
+	if(t1)
+	{
+		send_sig(SIGALRM, t1, 1);
+		free_task_struct(t1);
+	}
+	if(t2)
+	{
+		send_sig(SIGALRM, t2, 1);
+		free_task_struct(t2);
+	}
+
+	lock_mosix();
+	while ((mig_daemon_active || info_daemon_active) &&
+						!signal_pending(current))
+	{
+		unlock_mosix();
+		set_current_state(TASK_INTERRUPTIBLE);
+		schedule_timeout(HZ/10);
+		lock_mosix();
+	}
+	unlock_mosix();
+	set_current_state(TASK_RUNNING);
+	if (signal_pending(current))
+	{
+		error = -ERESTART;
+		goto fail;
+	}
+
+	printk(KERN_NOTICE "openMosix configuration disabled\n");
+	unregister_reboot_notifier(&mosix_notifier);
+
+	if (svnmton) {
+		kfree(svmton);
+		kfree(mosnetstat);
+	}
+	
+	lock_mosix();
+	pe_ready = 0;
+	unlock_mosix();
+#ifdef CONFIG_MOSIX_FS
+	mfs_change_pe();
+#endif /* CONFIG_MOSIX_FS */
+
+	return (0);
+
+fail:
+	lock_mosix();
+	PE = svpe;
+	NPE = svnpe;
+	MAXPE = svmaxpe;
+	mosnet = svmton;
+	nmosnet = svnmton;
+	unlock_mosix();
+	wake_up(&wait_for_mosix_config);
+	return (error);
+}
+
+void
+wait_for_mosix_configuration(int *active)
+{
+	struct task_struct *p = current;
+	DECLARE_WAITQUEUE(wait, current);
+
+	if(active)
+	{
+		lock_mosix();
+		*active = 0;
+		unlock_mosix();
+	}
+	add_wait_queue(&wait_for_mosix_config, &wait);
+	while(1)
+	{
+		if(p->sigpending)
+			flush_signals(p);
+		set_current_state(TASK_INTERRUPTIBLE);
+		if(PE)
+			break;
+		schedule();
+	}
+	remove_wait_queue(&wait_for_mosix_config, &wait);
+	set_current_state(TASK_RUNNING);
+	if(signal_pending(p))
+	{
+		spin_lock_irq(&p->sigmask_lock);
+		flush_signals(p);
+		spin_unlock_irq(&p->sigmask_lock);
+	}
+	if(active)
+	{
+		lock_mosix();
+		*active = 1;
+		unlock_mosix();
+	}
+}
+
+int
+mosix_config_get_table(struct mosixnet **mos, int start, int count)
+{
+	int copy;
+
+	if (count > MAX_MOSNET_ENTS)
+		count = MAX_MOSNET_ENTS;
+	if(!count)
+		count = nmosnet - start;
+	if(!PE || count < 0)
+		return(-ENXIO);
+	if(count == 0)
+		return(0);
+	*mos = (struct mosixnet *)
+		kmalloc(sizeof(struct mosixnet) * count, GFP_USER);
+	if(!*mos)
+		return(-ENOMEM);
+	lock_mosix();
+	if(!PE || !nmosnet || nmosnet < start)
+	{
+		unlock_mosix();
+		kfree(*mos);
+		return(-ENXIO);
+	}
+	if(nmosnet == start)
+	{
+		unlock_mosix();
+		kfree(*mos);
+		return(0);
+	}
+
+	/* create a private copy */
+	copy = nmosnet - start;
+	if (copy > count)
+		copy = count;
+	memcpy(*mos, &mosnet[start], sizeof(struct mosixnet) * copy);
+	unlock_mosix();
+	return (copy);
+}
+
+int
+mosix_config_set_table(struct mosixnet *m, int nents, int newpe)
+{
+	register int i, j;
+	register struct mosixnet *t, *q;
+	char *mstat = NULL;
+	char foundme = 0;
+	int maxpe = 1;
+	int numpe = 0;
+	int error = 0;
+
+	if (!boot_cpu_data.hard_math)
+	{
+		printk("Sorry, openMosix requires a math-unit.\n");
+		return(-ENODEV);
+	}
+	if(!spin_trylock(&modifying))
+		return(-EBUSY);
+	error = -E2BIG;
+	if (nents > MAX_MOSNET_ENTS)
+		goto out;
+
+	/*
+	 * PE == 0: (1)	newpe == 0 || nents == 0  =>  return (0)
+	 * 	    (2)	newpe > 0 && nents != 0   =>  (regular)
+	 * PE != 0: (3) newpe == PE		  =>  (regular)
+	 *	    (4)	newpe == 0 || nents == 0  =>  (shutdown)
+	 *          (5) newpe > 0 (nmosnet == 1)  =>  change PE, (regular)
+	 */
+
+	if(!newpe || !nents)
+	{
+		if(m)
+			kfree(m);
+		error = PE ? config_shutdown() : 0;
+		goto out;
+	}
+
+	error = -EBUSY;
+	if(PE && newpe != PE &&
+		(nmosnet != 1 || m->cnt != 1 || m->base != newpe))
+		goto out;
+
+	if(newpe == PE && nents == nmosnet &&
+		!memcmp(m, mosnet, nmosnet * sizeof(struct mosixnet)))
+	{
+		/* no change */
+		error = 0;
+		kfree(m);
+		goto out;
+	}
+
+
+	/* convention: first entry must hold the network type (AF_xxx) */
+	error = -EINVAL;
+	if (m->saddr.sa_family != AF_INET)
+		goto out;
+	comm_type = m->saddr.sa_family;
+
+	/* consistency checks */
+
+	for (t = m, i = 0; i < nents; i++, t++) {
+		t->saddr.sa_family = comm_type;
+
+		if (t->cnt < 0 || t->base < 1 || t->base + t->cnt < 0 ||
+			t->base + t->cnt - 1 > MOSIX_MAX)
+			goto out;
+
+		if (t->cnt == 0)
+		{
+			for (q = m, j = 0 ; j < nents ; j++ , q++)
+			if (q->cnt > 0 && q->base <= t->base &&
+				q->base + q->cnt > t->base)
+				break;
+			if(j == nents)
+			{
+				error = -ESRCH;
+				goto out;
+			}
+		}
+		else
+		{
+			for (q = m, j = 0; j < i; j++, q++)
+			if (q->cnt && (
+			    (q->base < t->base && q->base + q->cnt > t->base) ||
+			    (q->base >= t->base && q->base < t->base + t->cnt)))
+			{
+				error = -EXDEV;
+				goto out;
+			}
+
+			if (t->base + t->cnt - 1 > maxpe)
+				maxpe = t->base + t->cnt - 1;
+
+			if (newpe >= t->base && newpe < t->base + t->cnt)
+				foundme = 1;
+
+			numpe += t->cnt;
+		}
+	}
+	switch (comm_type) {
+	case AF_INET:
+		error = ip_consistent(newpe, m, nents, numpe);
+		break;
+	default:
+		error = 0;
+	}
+	if (error)
+		goto out;
+	error = -ESRCH;
+	if (!foundme)
+		goto out;
+	error = -ENOMEM;
+	i = (maxpe + 7) >> 3;
+	if (!(mstat = (char *) kmalloc(i, GFP_KERNEL)))
+		goto out;
+	memset(mstat, 0, i);
+
+
+	if(PE && (error = config_reduce_to_common(m, nents)))
+	{
+		kfree(mstat);
+		goto out;
+	}
+
+	/* COMMIT POINT */
+
+	lock_mosix();
+	write_lock(&mosnetstat_lock);
+	if (PE) {
+		unsigned int i, j;
+		int n;
+
+		if(newpe == PE)
+		for (i = 0; i < nents; i++)
+		for (n = m[i].base - 1 , j = 0 ; j < m[i].cnt ; j++ , n++)
+			mstat[n >> 3] |= (mosnetstat[n >> 3] & (1 << (n & 7)));
+		kfree(mosnetstat);
+		kfree(mosnet);
+	}
+
+	mosnetstat = mstat;
+	NPE = numpe;
+	MAXPE = maxpe;
+	nmosnet = nents;
+	mosnet = m;
+	write_unlock(&mosnetstat_lock);
+
+	pe_ready = newpe;
+	if(newpe != PE)
+	{
+		i = PE;
+		PE = newpe;
+		mos_to_net(PE, (void *)&my_mosix_net_address);
+		unlock_mosix();
+		info_startup();
+		if (!i)
+		{
+			comm_startup();
+			register_reboot_notifier(&mosix_notifier);
+			wake_up(&wait_for_mosix_config);
+		}
+	}
+	else
+		unlock_mosix();
+#ifdef CONFIG_MOSIX_FS
+	mfs_change_pe();
+#endif /* CONFIG_MOSIX_FS */
+	printk(KERN_NOTICE "openMosix configuration %s: This is openMosix #%d "
+		"(of %d configured)\n", PE ? "changed" : "set", newpe, NPE);
+	switch (comm_type)
+	{
+		case AF_INET:
+			ip_showconf(newpe, mosnet, nmosnet);
+			break;
+	}
+	error = 0;
+
+	out:
+	spin_unlock(&modifying);
+	return(error);
+}
+
+/* nth_node: n starts at 0 and does not count the local node */
+int
+nth_node(int n)
+{
+	register unsigned int i;
+	struct mosixnet *t;
+	int wanted = n;
+	MOSIX_LOCKED;
+	for(t = mosnet , i = 0 ; i < nmosnet ; i++ , t++)
+	{
+		if(t->base <= PE && t->base + t->cnt > PE)
+		{
+			if(t->base + n < PE)
+				return(t->base + n);
+			n++;
+		}
+		if(t->cnt <= n)
+			n -= t->cnt;
+		else
+			return(t->base + n);
+	}
+	panic("nth_node: attempt to find node %d", wanted);
+}
+
+int
+mosix_config_get_pe(void)
+{
+	return (PE);
+}
+
+int
+mosix_config_get_tentative_pe(void)
+{
+	int ret;
+
+	lock_mosix();
+	ret = pe_ready;
+	unlock_mosix();
+	return(ret);
+}
+
+int
+mosix_config_get_limit(void)
+{
+	int ret;
+
+	lock_mosix();
+	ret = PE ? MAXPE : 0;
+	unlock_mosix();
+	return(ret);
+}
+
+int
+mosix_config_set_pe(int newpe)
+{
+	int error = 0;
+
+	if (newpe < 0 || newpe > MOSIX_MAX)
+		return (-EINVAL);
+	if(!spin_trylock(&modifying))
+		return(-EBUSY);
+
+
+	if (!PE) {
+		lock_mosix();
+		pe_ready = newpe;
+		unlock_mosix();
+		goto out;
+	}
+
+	if (newpe == PE)
+		goto out;
+	
+	error = -EBUSY;
+	if (newpe && (nmosnet > 1 || mosnet->cnt != 1))
+		goto out;
+
+	if (newpe)
+	{
+		struct mosixnet m = *mosnet;
+
+		spin_unlock(&modifying);
+		m.base = newpe;
+		m.cnt = 1;
+		error = mosix_config_set_table(&m, 1, newpe);
+	}
+	else
+	{
+		spin_unlock(&modifying);
+		error = mosix_config_set_table(NULL, 0, 0);
+	}
+	return(error);
+	out:
+	spin_unlock(&modifying);
+	return (error);
+}
+
+/*
+ * mos_to_net:  return 1 if mos# exists (possibly fill sockaddr)
+ */
+int
+mos_to_net(int mos, void *sa)
+{
+	unsigned int n;
+	int ret = 0;
+
+
+	lock_mosix();
+	for (n = 0; n < nmosnet; n++)
+	if (mos >= mosnet[n].base && mos < mosnet[n].base + mosnet[n].cnt)
+	{
+		if(sa)
+		switch (comm_type) {
+		case AF_INET:
+			ip_mos_to_net(mos, n, (struct sockaddr *)sa);
+			break;
+		case AF_INET6:
+			panic("mos_to_net: AF_INET6 unsupported");
+			/* NOT REACHED */
+		default:
+			panic("mos_to_net: unknown type");
+		}
+		ret = 1;
+	}
+	unlock_mosix();
+	return(ret);
+}
+
+int
+mymos_to_net(void *sa)
+{
+	int ret = 0;
+
+	lock_mosix();
+	if(PE)
+		*(struct sockaddr *)sa = my_mosix_net_address;
+	else
+		ret = -ENETDOWN;
+	unlock_mosix();
+	return(ret);
+}
+
+int
+count_mosix_nodes(void)
+{
+	int unsigned i;
+	int n = 0;
+
+	lock_mosix();
+	for(i = 0 ; i < nmosnet ; i++)
+		n += mosnet[i].cnt;
+	unlock_mosix();
+	return(n);
+}
+
+#ifdef CONFIG_MOSIX_FS
+int
+scan_mosix_nodes(int start, int *first, int *last)
+{
+	unsigned int i;
+	int max = MOSIX_MAX + 1;
+
+	lock_mosix();
+	for(i = 0 ; i < nmosnet ; i++)
+	if(mosnet[i].cnt && mosnet[i].base < max &&
+		mosnet[i].base + mosnet[i].cnt > start)
+	{
+		*last = mosnet[i].base + mosnet[i].cnt - 1;
+		if(mosnet[i].base <= start)
+		{
+			*first = start;
+			max = 0;	/* eg. return(1) */
+			break;
+		}
+		*first = mosnet[i].base;
+		max = mosnet[i].base;
+	}
+	unlock_mosix();
+	return(max != MOSIX_MAX+1);
+}
+#endif /* CONFIG_MOSIX_FS */
+
+int
+mos_to_ascii(int mos, char *str, int len)
+{
+	struct sockaddr sa;
+
+	if (!mos_to_net(mos, &sa))
+		return (-EDIST);
+	switch (comm_type) {
+	case AF_INET:
+		return (ip_addr_to_ascii(&sa, str, len));
+	case AF_INET6:
+		panic("mos_to_ascii: AF_INET6 unsupported");
+	default:
+		panic("mos_to_ascii: unknown type");
+	}
+}
+
+
+int
+net_to_mos(mosix_addr *sa)
+{
+	switch (comm_type) {
+	case AF_INET:
+		return (ip_to_mosix(&sa->saddr));
+		/* NOT REACHED */
+	case AF_INET6:
+		panic("net_to_mos: AF_INET6 unsupported");
+		/* NOT REACHED */
+	default:
+		return(0);
+	}
+}
+
+int
+config_validate(void)
+{
+	register struct task_struct *p;
+	DECLARE_WAITQUEUE(wait, current);
+	int err = 0;
+
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if((p->mm || (p->mosix.dflags & (DDEPUTY|DREMOTE))) &&
+		!(p->mosix.dflags & DFINISHED))
+	{
+		tell_process(p, DREQ_CHECKCONF);
+		wake_up_mosix(p);
+	}
+	read_unlock(&tasklist_lock);
+	add_wait_queue(&wait_for_all_to_adjust, &wait);
+	while(1)
+	{
+		set_current_state(TASK_INTERRUPTIBLE);
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if(process_told(p, DREQ_CHECKCONF))
+			break;
+		read_unlock(&tasklist_lock);
+		if(p == &init_task)
+			break;
+		schedule();
+		if (signal_pending(current))
+		{
+			err = -ERESTARTSYS;
+			break;
+		}
+	}
+	remove_wait_queue(&wait_for_all_to_adjust, &wait);
+	set_current_state(TASK_RUNNING);
+	return(err);
+}
+
+static int
+config_reduce_to_common(struct mosixnet *nm, int nmn)
+{
+	struct mosixnet *mt, *svmton;
+	int svnmton, svnumpe, svmaxpe;
+	int error;
+	int newmaxpe=0;
+	int newnumpe=0;
+	int i;
+	
+	switch (comm_type) {
+	case AF_INET:
+		mt = ip_reduce_to_common(nm, &nmn);
+		break;
+	case AF_INET6:
+		panic("config_reduce_to_common: AF_INET6 unsupported");
+		/* NOT REACHED */
+	default:
+		panic("config_reduce_to_common: unknown type");
+	}
+
+	if (!mt)
+		return (-ENOMEM);
+
+	for(svmton = mt, i = 0; i < nmn; i++, svmton++)
+	{
+		newnumpe += svmton->cnt;
+		if (svmton->base + svmton->cnt - 1 > newmaxpe)
+			newmaxpe = svmton->base + svmton->cnt - 1;
+	}
+	svmton = mosnet;
+	svnmton = nmosnet;
+	svnumpe = NPE;
+	svmaxpe = MAXPE;
+	lock_mosix();
+	mosnet = mt;
+	nmosnet = nmn;
+	NPE = newnumpe;
+	MAXPE = newmaxpe;
+	unlock_mosix();
+
+
+	info_reconfig();
+
+	if ((error = config_validate())) {
+		lock_mosix();
+		mosnet = svmton;
+		nmosnet = svnmton;
+		NPE = svnumpe;
+		MAXPE = svmaxpe;
+		unlock_mosix();
+		kfree(mt);
+		return (error);
+	}
+
+
+	kfree(svmton);
+	return(0);
+}
+
+int
+i_am_in_a_wrong_place(void)
+{
+	register struct task_struct *p = current;
+
+	if(p->mosix.dflags & (DPASSING|DINCOMING))
+		return(0);	/* not time to hit yet */
+	switch(p->mosix.dflags & (DDEPUTY|DREMOTE))
+	{
+	case DREMOTE:
+		if (mos_to_net(p->mosix.deppe, 0) == 0)
+		{
+			return(1);
+		}
+		break;
+	case DDEPUTY:
+		if (mos_to_net(p->mosix.whereami, 0) == 0)
+		{
+			return(1);
+		}
+	}
+	done_checking_conf();
+	return(0);
+}
+
+void
+done_checking_conf(void)
+{
+	register struct task_struct *p;
+
+	read_lock(&tasklist_lock);
+	process_ack(current, DREQ_CHECKCONF);
+	for_each_task(p)
+		if(process_told(p, DREQ_CHECKCONF))
+			break;
+	read_unlock(&tasklist_lock);
+	if(p == &init_task)	/* we were last to check */
+		wake_up(&wait_for_all_to_adjust);
+}
+
+
+
+/*
+ * Network dependent part of config:
+ * current implementation support only IP (not including v6).
+ */
+
+#define NET_TO_IP(sa)	(((struct sockaddr_in *) &(sa))->sin_addr.s_addr)
+#define NET_TO_IP_H(sa)	(ntohl(NET_TO_IP(sa)))
+
+static void
+ip_mos_to_net(int mos, int n, struct sockaddr *sa)
+{
+	*sa = mosnet[n].saddr;
+	NET_TO_IP(*sa) = htonl(NET_TO_IP_H(*sa) + mos - mosnet[n].base);
+}
+
+
+static int
+ip_to_mosix(struct sockaddr *sa)
+{
+	int i, ip, mip, c, ret = 0;
+
+	ip = NET_TO_IP_H(*sa);
+
+	lock_mosix();
+	for (i = 0 ; i < nmosnet ; i++)
+	{
+		mip = NET_TO_IP_H(mosnet[i].saddr);
+		c = mosnet[i].cnt ? : 1;
+		if(ip >= mip && ip < mip + c)
+		{
+			ret = mosnet[i].base + ip - mip;
+			break;
+		}
+	}
+	unlock_mosix();
+	return(ret);
+}
+
+static struct mosixnet *
+ip_reduce_to_common(struct mosixnet *nm, int *nmn)
+{
+	struct mosixnet *mt;
+	register int i, j, n = 0;
+	int b1, e1, b2, e2;
+
+	/* 2*MAX_MOSNET_ENTS should cover the worst-case intersection */
+
+	mt = kmalloc(2 * MAX_MOSNET_ENTS * sizeof(struct mosixnet), GFP_KERNEL);
+	if (!mt)
+		return (0);
+	for (i = 0; i < *nmn; i++)
+	for (j = 0; j < nmosnet; j++)
+	if (NET_TO_IP_H(mosnet[j].saddr) - mosnet[j].base ==
+					NET_TO_IP_H(nm[i].saddr) - nm[i].base)
+	{
+		if ((nm[i].cnt != 0) != (mosnet[j].cnt != 0))
+			continue;
+		b1 = nm[i].base;
+		e1 = nm[i].base + nm[i].cnt - 1;
+		b2 = mosnet[j].base;
+		e2 = mosnet[j].base + mosnet[j].cnt - 1;
+
+		if (b2 > b1)
+			b1 = b2;
+		if (e2 < e1)
+			e1 = e2;
+		if (e1 >= b1) {
+			mt[n].base = b1;
+			mt[n].cnt = e1 - b1 + 1;
+			mt[n].saddr.sa_family = AF_INET;
+			NET_TO_IP(mt[n].saddr) = htonl(NET_TO_IP_H(nm[i].saddr)
+							+ b1 - nm[i].base);
+			n++;
+		}
+	}
+	*nmn = n;
+	return (mt);
+}
+
+static int
+ip_consistent(int pe, struct mosixnet *m, int nents, int numpe)
+{
+	unsigned int i, j;
+	struct mosixnet *t, *q;
+
+	for (t = m, i = 0; i < nents; i++, t++)
+	if (t->cnt == 0)		/* an ALIAS address */
+	for (q = m , j = 0 ; j < i ; j++ , q++)
+	{
+		/* check if this IP appears more than once */
+		if (q->cnt == 0 &&
+			NET_TO_IP_H(q->saddr) == NET_TO_IP_H(t->saddr))
+		{
+			if (q->base != t->base)
+				return (-EXDEV);
+		}
+		else if (q->cnt != 0 &&
+			NET_TO_IP_H(q->saddr) <= NET_TO_IP_H(t->saddr) &&
+			NET_TO_IP_H(q->saddr) + q->cnt > NET_TO_IP_H(t->saddr)
+			&& q->base + NET_TO_IP_H(t->saddr) -
+				NET_TO_IP_H(q->saddr) != t->base)
+				return (-EXDEV);
+	}
+	else				/* a normal range */
+	{
+		if (NET_TO_IP_H(t->saddr) + t->cnt <= NET_TO_IP_H(t->saddr))
+			return (-EINVAL);
+
+		for (q = m , j = 0 ; j < i ; j++ , q++)
+		if (q->cnt == 0 &&
+		    NET_TO_IP_H(t->saddr) <= NET_TO_IP_H(q->saddr) &&
+		    NET_TO_IP_H(t->saddr)+t->cnt > NET_TO_IP_H(q->saddr)
+		    && t->base + NET_TO_IP_H(q->saddr) - NET_TO_IP_H(t->saddr)
+		       != q->base)
+			return (-EXDEV);
+		else if (q->cnt != 0 && (
+		    (NET_TO_IP_H(q->saddr) < NET_TO_IP_H(t->saddr) &&
+		     NET_TO_IP_H(q->saddr) + q->cnt > NET_TO_IP_H(t->saddr)) ||
+		    (NET_TO_IP_H(q->saddr) >= NET_TO_IP_H(t->saddr) &&
+		     NET_TO_IP_H(q->saddr) < NET_TO_IP_H(t->saddr) + t->cnt)))
+			return (-EXDEV);
+	}
+
+	if (PE && numpe > 1)
+	/* allow change of address only if PE remains alone */
+	for (t = m, i = 0; i < nents; i++, t++)
+	{
+		struct sockaddr sa;
+
+		if (t->cnt != 0 && pe >= t->base && pe < t->base + t->cnt &&
+			(!mos_to_net(pe, &sa) || NET_TO_IP_H(sa) !=
+				NET_TO_IP_H(t->saddr) + (pe - t->base)))
+				return (-EBUSY);
+	}
+
+	return (0);
+}
+
+
+static int
+ip_addr_to_ascii(struct sockaddr *sa, char *buf, int len)
+{
+	int a, b, c, d;
+	char tmp[20];	/* should be enough for ALL inet addresses */
+	unsigned long ipaddr;
+	
+	ipaddr = htonl(((struct sockaddr_in *) sa)->sin_addr.s_addr);
+
+	a = (ipaddr & 0xff000000) >> 24;
+	b = (ipaddr & 0x00ff0000) >> 16;
+	c = (ipaddr & 0x0000ff00) >> 8;
+	d = (ipaddr & 0x000000ff);
+
+	sprintf(tmp, "%d.%d.%d.%d", a, b, c, d);
+	strncpy(buf, tmp, len - 1);
+	buf[len - 1] = '\0';
+	return (strlen(tmp));
+}
+
+
+static void
+ip_showconf(int pe, struct mosixnet *m, int nents)
+{
+	unsigned int i;
+	int a, b, c, d;
+	long ipaddr;
+
+	for(i = 0 ; i < nents ; i++, m++)
+	{
+		ipaddr = ntohl(NET_TO_IP(m->saddr));
+		a = (ipaddr & 0xff000000) >> 24;
+		b = (ipaddr & 0x00ff0000) >> 16;
+		c = (ipaddr & 0x0000ff00) >> 8;
+		d = ipaddr & 0xff;
+		if (m->cnt == 0)
+			printk(KERN_NOTICE "openMosix #%d is aliased to IP address "
+					"%d.%d.%d.%d\n", m->base, a, b, c, d);
+		else if (m->cnt == 1)
+			printk(KERN_NOTICE "openMosix #%d is at IP address "
+					"%d.%d.%d.%d\n", m->base, a, b, c, d);
+		else
+			printk(KERN_NOTICE "openMosix range: %d-%d begins at "
+					"%d.%d.%d.%d\n", m->base,
+					m->base + m->cnt - 1, a, b, c, d);
+	}
+}
+
diff -Naur --exclude=CVS --exclude=configs linux/hpc/decay.c linux-openmosix/hpc/decay.c
--- linux/hpc/decay.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/decay.c	2002-07-10 15:20:15.000000000 +0200
@@ -0,0 +1,243 @@
+/* All changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+
+#include <linux/config.h>
+#include <linux/sched.h>
+#include <linux/hpc.h>
+#include <linux/hpcctl.h>
+#include <linux/smp_lock.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <hpc/balance.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+
+int slow_alpha = DEFAULT_SLOW_ALPHA;
+int fast_alpha = DEFAULT_FAST_ALPHA;
+int decay_interval = DEFAULT_DECAY_INTERVAL;
+
+void
+mosix_decay_exec(void)
+{
+	register typeof (current->mosix.dpolicy) *p = &current->mosix.dpolicy;
+
+	if(!(*p & (DADV_EXEC|DADV_EXECONCE)))
+		*p = (*p & ~DADV_POLICY) | DADV_DEFAULT;
+	*p &= ~DADV_EXECONCE;
+}
+
+int
+decay_modify_bit(int on, int bit)
+{
+	if(on == -1)
+		return((current->mosix.dpolicy & bit) != 0);
+	if((on != 0) == ((current->mosix.dpolicy & bit) != 0))
+		return(0);
+	if(on)
+		current->mosix.dpolicy |= bit;
+	else
+		current->mosix.dpolicy &= ~bit;
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_update_remote_decay();
+	return(0);
+}
+
+int
+decay_inherit(int on)
+{
+	return(decay_modify_bit(on, DADV_INHERIT));
+}
+
+int
+decay_exec(int on)
+{
+	return(decay_modify_bit(on, DADV_EXEC));
+}
+
+int
+decay_execonce(int on)
+{
+	return(decay_modify_bit(on, DADV_EXECONCE));
+}
+
+int
+decay_set(int policy, int quotient, int seconds)
+{
+	register struct task_struct *p = current;
+	int prev;
+
+	if(policy == (p->mosix.dpolicy & DADV_POLICY) &&
+		(policy != DADV_OWNDECAY || (quotient == p->mosix.decay &&
+			seconds == p->mosix.deccycle)))
+		return(0);
+	if(seconds < 1 || seconds > 65535 ||
+		quotient < 0 || quotient > DECAY_QUOTIENT)
+		return(-EINVAL);
+	if(policy == DADV_CPU || policy == DADV_NOCPU ||
+		(prev = (p->mosix.dpolicy & DADV_POLICY)) == DADV_CPU ||
+			prev == DADV_NOCPU)
+			mosix_clear_statistics();
+	p->mosix.dpolicy = (p->mosix.dpolicy & ~DADV_POLICY) | policy;
+	p->mosix.decay = quotient;
+	p->mosix.deccycle = seconds;
+	if(p->mosix.dflags & DDEPUTY)
+		deputy_update_remote_decay();
+	return(0);
+}
+
+int
+decay_get(int policy)
+{
+	return((current->mosix.dpolicy & DADV_POLICY) == policy);
+}
+
+void
+decay_clear(void)
+{
+	struct decay_h d;
+
+	d.policy = DADV_CLEAR;
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_request(DEP_UPDATE_DECAY, &d, sizeof(d), NULL, 0, 0, NULL, 0);
+	else
+		mosix_clear_statistics();
+}
+
+void
+deputy_update_remote_decay(void)
+{
+	struct decay_h d;
+	struct mosix_task *m = &current->mosix;
+
+	d.policy = m->dpolicy;
+	d.deccycle = m->deccycle;
+	d.decay = m->decay;
+	deputy_request(DEP_UPDATE_DECAY, &d, sizeof(d), NULL, 0, 0, NULL, 0);
+}
+
+int
+remote_setdecay(struct decay_h *d)
+{
+	int prev, new;
+	struct mosix_task *m = &current->mosix;
+
+	if(d->policy == DADV_CLEAR)
+		mosix_clear_statistics();
+	else
+	{
+		prev = m->dpolicy & DADV_POLICY;
+		new = d->policy & DADV_POLICY;
+		if(prev == DADV_CPU || prev == DADV_NOCPU
+			|| new == DADV_CPU || new == DADV_NOCPU)
+			mosix_clear_statistics();
+		m->dpolicy = d->policy;
+		m->deccycle = d->deccycle;
+		m->decay = d->decay;
+	}
+	comm_free(d);
+	return(comm_send(DEP_UPDATE_DECAY|REPLY, NULL, 0, NULL, 0, 0));
+}
+ 
+void
+inc_decays(void)
+{
+	struct task_struct *p;
+	register struct mosix_task *m;
+	register unsigned char policy;
+
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	{
+		m = &p->mosix;
+		if(!(m->dflags & DDEPUTY) &&
+			((policy = m->dpolicy & DADV_POLICY) == DADV_SLOWDECAY
+				|| policy == DADV_FASTDECAY ||
+				policy == DADV_OWNDECAY) &&
+			m->decsecs != 0xffff)
+			m->decsecs++;
+	}
+	read_unlock(&tasklist_lock);
+}
+
+void
+do_decay(void)
+{
+	register struct mosix_task *m = &current->mosix;
+	int d;
+	int64_t ms;
+#ifdef CONFIG_MOSIX_FS
+	int i;
+#endif /* CONFIG_MOSIX_FS */
+	/* an expensive 64-bit-division saving macro: */
+#define	proportionate(fld) if(m->fld > (0xffffffffUL/DECAY_QUOTIENT)) \
+	m->fld = m->fld * d / DECAY_QUOTIENT; \
+	else m->fld = ((unsigned long)m->fld) * d / DECAY_QUOTIENT
+
+	switch(m->dpolicy & DADV_POLICY)
+	{
+	case DADV_SLOWDECAY:
+		if(m->decsecs < decay_interval)
+			return;
+		d = slow_alpha;
+		break;
+	case DADV_FASTDECAY:
+		if(m->decsecs < decay_interval)
+			return;
+		d = fast_alpha;
+		break;
+	case DADV_OWNDECAY:
+		if(m->decsecs < m->deccycle)
+			return;
+		d = m->decay;
+		break;
+	default:
+		return;
+	}
+	read_lock(&tasklist_lock);
+	m->decsecs = 0;
+	read_unlock(&tasklist_lock);
+	lock_mosix();
+	proportionate(cutime);
+	proportionate(ndemandpages);
+	proportionate(nsyscalls);
+	proportionate(ncopyins);
+	proportionate(copyinbytes);
+	proportionate(ncopyouts);
+	proportionate(copyoutbytes);
+	proportionate(pagetime);
+#ifdef CONFIG_MOSIX_FS
+	if(m->mfs_stats)
+	for(i = m->mfs_stats->nnodes-1 ; i >= 0 ; i--)
+	{
+		proportionate(mfs_stats->conns[i]);
+		proportionate(mfs_stats->inbytes[i]);
+		proportionate(mfs_stats->outbytes[i]);
+		if(m->mfs_stats->conns[i] == 0)
+		{
+			int last = --m->mfs_stats->nnodes;
+
+			if(i == last)
+				continue;
+			m->mfs_stats->nodes[i] = m->mfs_stats->nodes[last];
+			m->mfs_stats->conns[i] = m->mfs_stats->conns[last];
+			m->mfs_stats->inbytes[i] = m->mfs_stats->inbytes[last];
+			m->mfs_stats->outbytes[i] = m->mfs_stats->outbytes[last];
+			if(m->mfs_stats->hint == last)
+				m->mfs_stats->hint = i;
+		}
+	}
+#endif /* CONFIG_MOSIX_FS */
+
+	ms = ticks_to_ms(current->times.tms_utime + m->uttime) - m->dctime;
+	if(ms > 0)
+		m->dctime += ms * (DECAY_QUOTIENT - d) / DECAY_QUOTIENT;
+	unlock_mosix();
+}
